         title   ToolTemplate

         .586
         .model flat, stdcall
         option casemap:none   ; Case sensitive

            include  \MASM32V1\PROGRAMS\AsmEdit\include\Windows.inc
            include  \MASM32V1\PROGRAMS\AsmEdit\include\user32.inc
            include  \MASM32V1\PROGRAMS\AsmEdit\include\kernel32.inc
            include  \MASM32V1\PROGRAMS\AsmEdit\include\gdi32.inc
            include  \MASM32V1\PROGRAMS\AsmEdit\include\comctl32.inc
            include  \MASM32V1\PROGRAMS\AsmEdit\include\comdlg32.inc

   include  \MASM32V1\PROGRAMS\AsmEdit\include\DSPMACRO.asm

         includelib  \MASM32V1\PROGRAMS\AsmEdit\lib\user32.lib
         includelib  \MASM32V1\PROGRAMS\AsmEdit\lib\kernel32.lib
         includelib  \MASM32V1\PROGRAMS\AsmEdit\lib\gdi32.lib
         includelib  \MASM32V1\PROGRAMS\AsmEdit\lib\comctl32.lib
         includelib  \MASM32V1\PROGRAMS\AsmEdit\lib\comdlg32.lib

;===================================================
; PROTO, MACRO, and Data section
;===================================================
WinMain         PROTO  :DWORD, :DWORD, :DWORD, :DWORD
RichEditProc    PROTO  :DWORD, :DWORD, :DWORD, :DWORD

;Insert between
;++++ Proto & Macros ++++++++++++++++++++++++++++++++++++++++++++++++++
ChgBmpColor      PROTO :DWORD

;---------- [Toolbar structure macros] ----------
TBSep    MACRO hTool
           mov     tbb.iBitmap, 0
           mov     tbb.idCommand, 0
           mov     tbb.fsState, TBSTATE_ENABLED
           mov     tbb.fsStyle, TBSTYLE_SEP
        INVOKE     SendMessage, hTool, TB_ADDBUTTONS, 1, addr tbb
          ENDM

TBButt   MACRO hTool, BmpID, CmdID, State, Style, Text
           mov     tbb.iBitmap, BmpID    ; Button image number
           mov     tbb.idCommand, CmdID  ; Command ID number
           mov     tbb.fsState, State
           mov     tbb.fsStyle, Style
           mov     tbb.dwData, 0
           mov     tbb.iString, Text
        INVOKE     SendMessage, hTool, TB_ADDBUTTONS, 1, addr tbb
          ENDM
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

MOVmd    MACRO Var1, Var2
         push     Var2
          pop     Var1
         ENDM

.const
;Insert between
;++++ Constants +++++++++++++++++++++++++++++++++++++++++++++++++++++++
IDM_NEW            equ 1001
IDM_OPEN           equ 1002
IDM_SAVE           equ 1003
IDM_CUT            equ 1004
IDM_COPY           equ 1005
IDM_PASTE          equ 1006
IDM_DELETE         equ 1007
IDM_FIND           equ 1008
IDM_FINDNEXT       equ 1009
IDM_FINDPREV       equ 1010
IDM_REPLACE        equ 1011
IDM_EXIT           equ 1012
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
IDM_SELALL         equ 2009

.data
RichEdit       db  'RichEdit20A',0
RichEdDLL      db  'RICHED20.DLL',0
FontNameCN     db  'Courier New',0
PopupMenu      db  'PopupMenu',0
FontHeight     dd  -12
FontW          dd  400
StatClass      db  'msctls_statusbar32',0
szPart1        db  'Part 1',0
szPart3        db  'Part 3',0
ClassName      db  'ToolTemplate',0
AppName        db  'ToolTemplate',0
MenuName       db  'MainMenu',0
szNull         db  0

;Insert between
;++++ .data +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ToolClass      db  'ToolbarWindow32',0
FloatTBClass   db  'FloatToolbar32',0

TextC01        db  'New',0
TextC02        db  'Open',0
TextC03        db  'Save',0
TextC04        db  'Save All',0
TextC05        db  'Cut',0
TextC06        db  'Copy',0
TextC07        db  'Paste',0
TextC08        db  'Delete',0
TextC09        db  'Undo',0
TextC10        db  'Redo',0
TextC11        db  'Find',0
TextC12        db  'FindN',0
TextC13        db  'FindP',0
TextC14        db  'Rep',0
TextC15        db  'MultiI',0
TextC16        db  'Exit',0
szTextC        dd  TextC01,TextC02,TextC03,TextC04,TextC05,TextC06,
                   TextC07,TextC08,TextC09,TextC10,TextC11,TextC12,
                   TextC13,TextC14,TextC15,TextC16

szSpace        db  ' ',0

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

szError1       db  'The RICHED20.DLL was not found!',0
.data?
hInst          dd  ?
CommandLine    dd  ?
MainExit       dd  ?
hWnd           dd  ?
hREdDll        dd  ?
hREdit         dd  ?
hSMenu         dd  ?
lpRichEdit     dd  ?
hFont          dd  ?
FontName       db  64  dup(?)
hWndStat       dd  ?
sbParts        dd  4   dup(?)
MenuCnt        dd  ?

;Insert between
;++++ .data? ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
hWndTool       dd  ?
hImageList     dd  ?

LeftOn         dd  ?
TopOn          dd  ?
RightOn        dd  ?
BottomOn       dd  ?
TBLeft         dd  ?
TBTop          dd  ?
TBWth          dd  ?
TBHgt          dd  ?

hWndDock       dd  ?
hWndFloat      dd  ?
hWndToolF      dd  ?
Styles         dd  ?
DockW          dd  ?
DockH          dd  ?
ToolW          dd  ?
ToolH          dd  ?
FloatLock      dd  ?
LockOn         dd  ?

SavID          dd  ?
szTextA        db  32  dup(?)

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;---------- [Structures] ----------
tbi            TBBUTTONINFO <>

.code

;===================================================
; Program initialization section
;===================================================
start:
      INVOKE     GetModuleHandle, NULL
         mov     hInst, eax
      INVOKE     GetCommandLine
         mov     CommandLine, eax

        call     InitCommonControls
      INVOKE     LoadLibrary, addr RichEdDLL ; Load the Riched20.dll
         mov     hREdDll, eax
      .if !eax
         INVOKE     MessageBox, NULL, addr szError1, addr AppName, MB_OK or MB_ICONERROR
            jmp     NoGo
      .endif

      INVOKE     WinMain, hInst ,NULL, CommandLine, SW_SHOWDEFAULT
         mov     MainExit, eax
      INVOKE     FreeLibrary, hREdDll

NoGo:
      INVOKE     ExitProcess, MainExit

;===================================================
; WinMain procedure
;===================================================
WinMain proc  uses ebx  hinst:DWORD, hPrevInst, CmdLine, CmdShow
LOCAL    wc:WNDCLASSEX
LOCAL    msg:MSG

         mov     wc.cbSize, sizeof WNDCLASSEX
         mov     wc.style, CS_HREDRAW or CS_VREDRAW
         mov     wc.lpfnWndProc, offset WndProc
         mov     wc.cbClsExtra, NULL
         mov     wc.cbWndExtra, NULL
        push     hInst
         pop     wc.hInstance
         mov     wc.hbrBackground, COLOR_BTNFACE+1
         mov     wc.lpszMenuName, offset MenuName
         mov     wc.lpszClassName, offset ClassName
      INVOKE     LoadIcon, NULL, IDI_APPLICATION
         mov     wc.hIcon, eax
         mov     wc.hIconSm, eax
      INVOKE     LoadCursor, NULL, IDC_ARROW
         mov     wc.hCursor, eax
      INVOKE     RegisterClassEx, addr wc

;Insert between if any
;++++ Float/Dock Class ++++++++++++++++++++++++++++++++++++++++++++++++
          or     wc.style, CS_DBLCLKS
         mov     wc.lpfnWndProc, offset FloatWndProc
         mov     wc.lpszClassName, offset FloatTBClass
         mov     wc.lpszMenuName, NULL
      INVOKE     RegisterClassEx, addr wc
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;---------- [Center the window] ----------
      INVOKE     GetSystemMetrics, SM_CXSCREEN
         sub     eax, 350
         shr     eax, 1
        push     eax
      INVOKE     GetSystemMetrics, SM_CYSCREEN
         sub     eax, 300
         shr     eax, 1
         pop     ebx

;---------- [Create the Main Window] ----------
      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr ClassName,\
                 addr AppName, WS_OVERLAPPEDWINDOW,\
                 ebx, eax, 350, 300, NULL, NULL, hInst, NULL
         mov     hWnd, eax

      INVOKE     ShowWindow, hWnd, SW_SHOWNORMAL
      INVOKE     UpdateWindow, hWnd

;---------- [Message loop] ----------
      .while TRUE
         INVOKE     GetMessage, addr msg, NULL, 0, 0
            .break .if (!eax)
            INVOKE     TranslateMessage, addr msg
            INVOKE     DispatchMessage, addr msg
      .endw
         mov     eax, msg.wParam
         ret
WinMain endp

;===================================================
; WinProc procedure
;===================================================
WndProc proc  uses ebx  hwnd:DWORD, wMsg, wParam, lParam
LOCAL    rect:RECT
LOCAL    lf:LOGFONT
LOCAL    charF:CHARFORMAT2

;Insert between
;++++ Locals ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
LOCAL    tbb:TBBUTTON
LOCAL    tbab:TBADDBITMAP
LOCAL    bSize:DWORD, hTbBmp, ID, Cnt, Len, Incr, xPos, yPos, WWth, WHgt
LOCAL    SavState:BYTE, SavStyle:BYTE
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
LOCAL    szBuff[64]:BYTE
;---------- [Create the Control(s) and one time stuff] ----------
      .if wMsg == WM_CREATE

;---------- [Create the status bar window] ----------
         INVOKE     CreateWindowEx, 0, addr StatClass, 0,\
                    WS_CHILD or WS_BORDER or WS_VISIBLE or SBS_SIZEGRIP,\
                    0, 0, 0, 0, hwnd, 0, hInst, 0  
         .if !eax
;Do message
               jmp     Ret0
         .endif
            mov     hWndStat, eax

;Insert between
;++++ Toolbar code ++++++++++++++++++++++++++++++++++++++++++++++++++++
;---------- [Create the Toolbar Window] ----------
         INVOKE     CreateWindowEx, 0, addr ToolClass, 0,\
                    WS_CHILD or WS_VISIBLE or WS_BORDER or CCS_TOP or \
                    CCS_NORESIZE or CCS_ADJUSTABLE or TBSTYLE_BUTTON or TBSTYLE_TOOLTIPS or \
                    TBSTYLE_FLAT,\
                    0, -2, 1200, 26, hwnd, 0, hInst, 0
            mov     hWndTool, eax

;---------- [Create the ImageList] ----------
         INVOKE     ImageList_Create, 16, 16, ILC_COLOR32, 16, 0
            mov     hImageList, eax

;---------- [Load The Bitmaps] ----------
            mov     ID, 701           ; Bitmap ID
            mov     Cnt, 16
         .while (Cnt)
            INVOKE     LoadImage, hInst, ID, IMAGE_BITMAP, 16, 16, LR_DEFAULTCOLOR
            INVOKE     ChgBmpColor, eax
               mov     hTbBmp, eax
            INVOKE     ImageList_Add, hImageList, hTbBmp, NULL
            INVOKE     DeleteObject, hTbBmp
               inc     ID
               dec     Cnt
         .endw

         INVOKE     SendMessage, hWndTool, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
         INVOKE     SendMessage, hWndTool, TB_SETIMAGELIST, 0, hImageList

;---------- [Size the Bitmap and Button] ----------
            mov     ecx, 16  ; loword = bitmap Width
            mov     eax, 16  ; hiword = bitmap Height
            shl     eax, 16
            mov     ax, cx
            mov     bSize, eax
         INVOKE     SendMessage, hWndTool, TB_SETBITMAPSIZE, 0, bSize
            mov     eax, 23  ; loword = button Width
            mov     ecx, 22  ; hiword = button Height
            shl     ecx, 16
            mov     cx, ax
         INVOKE     SendMessage, hWndTool, TB_SETBUTTONSIZE, 0, ecx

;---------- [Create the Toolbar structures] ----------
         TBButt     hWndTool, 0,IDM_NEW,4,0,0
         TBButt     hWndTool, 1,IDM_OPEN,4,0,0
         TBButt     hWndTool, 2,IDM_SAVE,4,0,0
          TBSep     hWndTool
         TBButt     hWndTool, 4,IDM_CUT,4,0,0
         TBButt     hWndTool, 5,IDM_COPY,4,0,0
         TBButt     hWndTool, 6,IDM_PASTE,4,0,0
         TBButt     hWndTool, 7,IDM_DELETE,4,8,0
          TBSep     hWndTool
         TBButt     hWndTool, 10,IDM_FIND,4,0,0
         TBButt     hWndTool, 11,IDM_FINDNEXT,4,0,0
         TBButt     hWndTool, 12,IDM_FINDPREV,4,0,0
         TBButt     hWndTool, 13,IDM_REPLACE,4,0,0
          TBSep     hWndTool
         TBButt     hWndTool, 15,IDM_EXIT,4,0,0

;---------- [Create the FloatToolbar] ----------
         INVOKE     CreateWindowEx, WS_EX_TOOLWINDOW or WS_EX_WINDOWEDGE, addr FloatTBClass,
                    0, WS_POPUP or\
                    WS_VISIBLE or WS_THICKFRAME, 346, 305, 31, 250,
                    hwnd, NULL, hInst, NULL
            mov     hWndFloat, eax

         INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                    WS_CHILD or WS_VISIBLE or TBSTYLE_TOOLTIPS or CCS_NOPARENTALIGN or\
                    CCS_NORESIZE or CCS_ADJUSTABLE or TBSTYLE_FLAT or\
                    TBSTYLE_WRAPABLE or CCS_NODIVIDER,\
                    -1, -1, 1200, 26, hWndFloat, 0, hInst, 0
            mov     hWndToolF, eax

         INVOKE     SendMessage, hWndToolF, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
         INVOKE     SendMessage, hWndToolF, TB_SETIMAGELIST, 0, hImageList

;---------- [Size the Bitmap and Button] ----------
            mov     ecx, 16  ; loword = bitmap Width
            mov     eax, 16  ; hiword = bitmap Height
            shl     eax, 16
            mov     ax, cx
            mov     bSize, eax
         INVOKE     SendMessage, hWndToolF, TB_SETBITMAPSIZE, 0, bSize
            mov     eax, 23  ; loword = button Width
            mov     ecx, 22  ; hiword = button Height
            shl     ecx, 16
            mov     cx, ax
         INVOKE     SendMessage, hWndToolF, TB_SETBUTTONSIZE, 0, ecx

;---------- [Create the Float Toolbar structures] ----------
         TBButt     hWndToolF, 0,IDM_NEW,4,0,0
         TBButt     hWndToolF, 1,IDM_OPEN,4,0,0
         TBButt     hWndToolF, 2,IDM_SAVE,4,0,0
         TBButt     hWndToolF, 4,IDM_CUT,4,0,0
         TBButt     hWndToolF, 5,IDM_COPY,4,0,0
         TBButt     hWndToolF, 6,IDM_PASTE,4,0,0
         TBButt     hWndToolF, 7,IDM_DELETE,4,0,0
         TBButt     hWndToolF, 10,IDM_FIND,4,0,0
         TBButt     hWndToolF, 11,IDM_FINDNEXT,4,0,0
         TBButt     hWndToolF, 12,IDM_FINDPREV,4,0,0
         TBButt     hWndToolF, 13,IDM_REPLACE,4,0,0
         TBButt     hWndToolF, 15,IDM_EXIT,4,0,0
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;---------- [Create the Edit Window] ----------
         INVOKE     CreateWindowEx, NULL, addr RichEdit, NULL,\
                    WS_CHILD or WS_VISIBLE or WS_BORDER or ES_MULTILINE or\
                    ES_NOHIDESEL or ES_SAVESEL or ES_SELECTIONBAR or\
                    WS_HSCROLL or ES_AUTOHSCROLL or\
                    WS_VSCROLL or ES_AUTOVSCROLL,\
                    0, 0, 0, 0, hwnd, 4444, hInst, NULL
         .if !eax
;Do message
               jmp     Ret0
         .endif
            mov     hREdit, eax

         INVOKE     SendMessage, hREdit, EM_EXLIMITTEXT, 0, 4000000
         INVOKE     SetFocus, hREdit

;---------- [Control window subclassed] ----------
         INVOKE     SetWindowLong, hREdit, GWL_WNDPROC, RichEditProc
            mov     lpRichEdit, eax

         INVOKE     LoadMenu, hInst, addr PopupMenu   
         INVOKE     GetSubMenu, eax, 0
            mov     hSMenu, eax

;---------- [Get the character format] ----------
            mov     charF.cbSize, sizeof charF
         INVOKE     SendMessage, hREdit, EM_GETCHARFORMAT, TRUE, addr charF
            mov     eax, FontW
            mov     charF.wWeight, ax   
         INVOKE     lstrcpy, addr FontName, addr FontNameCN

         INVOKE     RtlZeroMemory, addr lf, sizeof lf
         INVOKE     lstrcpy, addr lf.lfFaceName, addr FontName
           push     FontHeight
            pop     lf.lfHeight
            xor     eax, eax
            mov     ax, charF.wWeight
            mov     lf.lfWeight, eax
            mov     al, charF.bCharSet
            mov     lf.lfCharSet, al
            mov     al, charF.bPitchAndFamily
            mov     lf.lfPitchAndFamily, al
         INVOKE     CreateFontIndirect, ADDR lf
            mov     hFont, eax
         INVOKE     SendMessage, hREdit, WM_SETFONT, hFont, TRUE

         INVOKE     GetMenu, hwnd              ; Get the handle to the main menu
         INVOKE     GetSubMenu, eax, 0         ; Get handle to 1st sub menu
         INVOKE     GetMenuItemCount, eax      ; Get count of items in the sub menu
            mov     MenuCnt, eax               ; Menu count for ProcessMRUFiles

;Insert between
;++++ Set Dropdown ++++++++++++++++++++++++++++++++++++++++++++++++++++
         INVOKE     SendMessage, hWndTool, TB_SETEXTENDEDSTYLE, 0, TBSTYLE_EX_DRAWDDARROWS
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;Insert between
;++++ Set variables +++++++++++++++++++++++++++++++++++++++++++++++++++
;---------- [Set various values] ----------
            mov     LeftOn, 0
            mov     TopOn, 1
            mov     RightOn, 0
            mov     BottomOn, 0
            mov     TBLeft, -1
            mov     TBTop, -2
            mov     TBWth, 469
            mov     TBHgt, 26

            mov     tbi.cbSize, sizeof tbi

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;---------- [Move and Size the Control(s)] ----------
      .elseif wMsg == WM_SIZE

;Insert between
;++++ Sizing code +++++++++++++++++++++++++++++++++++++++++++++++++++++
;---------- [AutoSize the Toolbar Control] ----------
         INVOKE     SendMessage, hWndTool, TB_AUTOSIZE, 0, 0
         INVOKE     MoveWindow, hWndStat, 0, 0, 0, 0, TRUE

;---------- [Size the Edit Toolbar Controls] ----------
            xor     eax, eax             ; Zero out toolbar height
         .if hWndTool
            INVOKE     GetClientRect, hWnd, addr rect ; Rectangle of main window
               mov     eax, rect.right
               mov     WWth, eax
            .if TopOn || BottomOn
                  inc     eax
                  mov     TBWth, eax
            .endif
               mov     eax, rect.bottom
               mov     WHgt, eax
            INVOKE     GetWindowRect, hWndTool, addr rect ; Rectangle of toolbar
               mov     eax, rect.bottom
               sub     eax, rect.top
               mov     TBHgt, eax
            .if LeftOn || RightOn
                  mov     eax, WHgt
                  mov     TBHgt, eax
                  xor     eax, eax
            .endif
         .endif
           push     eax                  ; Save height of toolbar

            xor     eax, eax             ; Zero out statusbar height
         .if hWndStat
            INVOKE     GetWindowRect, hWndStat, addr rect ; Rectangle of statusbar
               mov     eax, rect.bottom
               sub     eax, rect.top     ; eax = height of statusbar
         .endif

            pop     edx                  ; edx = height of toolbar
         .if BottomOn
               and     edx, 0
         .endif
            mov     ebx, lParam          ; Width of new client area
            and     ebx, 0ffffh          ; ebx = width
            mov     ecx, lParam
            shr     ecx, 16              ; Height of new client area
            sub     ecx, eax             ; Edit window - height of statusbar
            sub     ecx, edx             ; Edit window - height of toolbar
         .if edx                         ; If toolbar
               sub     edx, 2            ; For border
               add     ecx, 2            ; For border
         .endif
         .if eax                         ; If statusbar
               add     ecx, 2            ; For border
         .endif

            and     xPos, 0
         .if LeftOn
               mov     eax, TBWth
               mov     xPos, eax
               sub     ebx, TBWth
               mov     TBHgt, ecx
         .endif
         .if RightOn
               mov     xPos, 0
               sub     ebx, TBWth
               mov     TBHgt, ecx
               mov     TBLeft, ebx
         .endif
         .if BottomOn
               sub     ecx, TBHgt
               add     ecx, 20      ; Statusbar height
               mov     TBTop, ecx
         .endif
         .if hWndDock
               mov     edx, 0
               add     ecx, TBHgt
               sub     ecx, 2
         .endif
         .if FloatLock
               mov     eax, ToolW
            .if ToolH > eax
                  add     eax, 6
                  mov     xPos, eax
                  sub     ebx, ToolW
                  sub     ebx, 6
            .else
                  mov     xPos, 0
                  add     edx, ToolH
                  add     edx, 6
                  sub     ecx, ToolH
                  sub     ecx, 6
            .endif
         .endif
         INVOKE     MoveWindow, hREdit, xPos, edx, ebx, ecx, TRUE
         INVOKE     MoveWindow, hWndTool, TBLeft, TBTop, TBWth, TBHgt, TRUE

;---------- [Size the Floating Toolbar] ----------
         .if hWndFloat && !ToolH
            INVOKE     GetWindowRect, hWnd, addr rect
               add     rect.left, 195
               add     rect.top, -29
               mov     rect.right, 94
               mov     rect.bottom, 0
               mov     ToolH, 1
            INVOKE     MoveWindow, hWndFloat, rect.left, rect.top, rect.right, rect.bottom, TRUE

         .elseif hWndFloat && FloatLock
            INVOKE     GetWindowRect, hREdit, addr rect
               mov     eax, rect.left
               sub     rect.right, eax
               mov     eax, rect.top
               sub     rect.bottom, eax
               mov     ecx, ToolW
            .if ecx < ToolH
                  add     ecx, 6
                  sub     rect.left, ecx
                  mov     edx, rect.bottom

            .else
                  mov     edx, ToolH
                  add     edx, 6
                  sub     rect.top, edx
                  mov     ecx, rect.right
            .endif
            INVOKE     MoveWindow, hWndFloat, rect.left, rect.top, ecx, edx, TRUE
         .endif

;---------- [Size the Docking Toolbar] ----------
         .if hWndDock
            INVOKE     SendMessage, hWndTool, TB_BUTTONCOUNT, 0, 0
               mov     Cnt, eax
               mov     ecx, Cnt
               dec     ecx
            INVOKE     SendMessage, hWndTool, TB_GETITEMRECT, ecx, addr rect
              push     rect.right
               pop     DockW
               add     DockW, 8
              push     rect.bottom
               pop     DockH
               add     DockH, 24
               inc     rect.right
               add     rect.bottom, 3

            INVOKE     MoveWindow, hWndTool, 0, -2, rect.right, rect.bottom, TRUE
            INVOKE     GetWindowRect, hWndDock, addr rect
              push     rect.left
              push     rect.top
            INVOKE     GetWindowRect, hWnd, addr rect
               pop     edx
               pop     ecx
            .if ecx == 0 || edx == 0
                  add     rect.left, 6
                  add     rect.top, 44
            .else
                  mov     rect.left, ecx
                  mov     rect.top, edx
            .endif
            INVOKE     MoveWindow, hWndDock, rect.left, rect.top, DockW, DockH, TRUE
         .endif
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;Insert between
;++++ MOVE or ACTIVATEAPP Msg +++++++++++++++++++++++++++++++++++++++++
;---------- [MOVE Msg] ----------
      .elseif wMsg == WM_MOVE
         .if FloatLock
               mov     LockOn, 1
         .endif
          call     SetSize

;---------- [ACTIVATEAPP Msg] ----------
      .elseif wMsg == WM_ACTIVATEAPP
         INVOKE     DefWindowProc, hWnd, WM_NCACTIVATE, wParam, 0 
            ret

      .elseif wMsg == WM_NCACTIVATE 
            mov     eax, TRUE 
            ret
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;Insert between
;++++ Notify code +++++++++++++++++++++++++++++++++++++++++++++++++++++
;---------- [Get Tooltips] ----------
      .elseif wMsg == WM_NOTIFY
            mov     ebx, lParam          ; Get pointer to NMHDR
            mov     eax, (NMHDR ptr [ebx]).code
         .if eax == TTN_NEEDTEXT
               mov     eax, (NMHDR ptr [ebx]).idFrom ; Resource id
               mov     ecx, eax
            INVOKE     LoadString, hInst, ecx, addr szBuff, lengthof szBuff
               mov     ebx, lParam                   ; Get the buffer addr
               lea     eax, szBuff
               mov     (TOOLTIPTEXT ptr [ebx]).lpszText, eax
               mov     eax, FALSE
               ret
         .endif
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;Insert between if any
;++++ Activate Docking Toolbar ++++++++++++++++++++++++++++++++++++++++
;---------- [Activate Docking Toolbar] ----------
         .if eax == NM_RDBLCLK && !hWndDock
            INVOKE     GetWindowLong, hWndTool, GWL_STYLE
               mov     Styles, eax
            .if (Styles & WS_BORDER)
                  xor     Styles, WS_BORDER
            .endif
            INVOKE     SetWindowLong, hWndTool, GWL_STYLE, Styles
            .if FloatLock
                  mov     LockOn, 1
            .endif
              call     DockToolbar
            INVOKE     SetFocus, hWndDock
               jmp     Ret0
         .endif
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;Insert between if any
;++++ Customize Toolbar code ++++++++++++++++++++++++++++++++++++++++++
;---------- [Customize the Toolbar] ----------
         .if eax == TBN_BEGINADJUST
               mov     eax, TRUE
               ret

; Add to Windows.inc Comctl32.dll version 5.80 or later- Removes the help button
         .elseif eax == TBN_FIRST-23 ;TBN_INITCUSTOMIZE
               mov     eax, 1        ;TBNRF_HIDEHELP
               ret

         .elseif eax == TBN_QUERYINSERT
               mov     eax, TRUE
               ret

         .elseif eax == TBN_QUERYDELETE
               mov     eax, TRUE
               ret

         .elseif eax == TBN_GETBUTTONINFO
               mov     eax, [ebx.TBNOTIFY].iItem ; Item num
            .if eax <= 16                    ; Num of images
                 push     ebx
                 push     eax
                  mov     Incr, eax
               INVOKE     SendMessage, hWndTool, TB_BUTTONCOUNT, 0, 0

;---------- [Find matching bitmap ID] ----------
                  and     ID, 0
                  and     Len, 0
                  mov     Cnt, eax
               .while (Cnt)
                  INVOKE     SendMessage, hWndTool, TB_GETBUTTON, ID, addr tbb
                     mov     eax, Incr
                  .if eax == tbb.iBitmap && tbb.fsStyle != TBSTYLE_SEP
                        mov     edx, tbb.idCommand
                        mov     al, tbb.fsState
                        mov     SavState, al
                        mov     al, tbb.fsStyle
                        mov     SavStyle, al
                     .break
                  .endif
                  .if tbb.fsStyle != TBSTYLE_SEP
                        inc     Len
                  .endif
                     inc     ID
                     dec     Cnt
               .endw
               .if !Cnt
                     xor     edx, edx
                     xor     esi, esi
               .endif
                  pop     eax
                  pop     ebx
               .if !edx                    ; No matching ID
                  mov     edx, eax
                     inc     edx
                     add     edx, 6900
                     mov     SavState, TBSTATE_ENABLED
                     mov     SavStyle, TBSTYLE_BUTTON
               .endif

                 push     eax
                  mov     [ebx.TBNOTIFY.tbButton].iBitmap, eax
                  mov     [ebx.TBNOTIFY.tbButton].idCommand, edx
                  mov     al, SavState
                  mov     [ebx.TBNOTIFY.tbButton].fsState, al ;TBSTATE_ENABLED
                  mov     al, SavStyle
                  mov     [ebx.TBNOTIFY.tbButton].fsStyle, al ;TBSTYLE_BUTTON
                  mov     [ebx.TBNOTIFY.tbButton].dwData, 0
                  pop     eax

                  lea     ecx, szSpace
                  xor     esi, esi
               .if eax < 16                ; Number of predefined names
                  pushad
                  INVOKE     lstrcpy, addr szTextA, szTextC[eax*4]
                   popad
                     lea     esi, szTextA
               .endif

               .if esi
                     mov     ecx, esi
                  pushad
                     mov     tbi.dwMask, TBIF_TEXT
                     mov     tbi.pszText, ecx
                     mov     SavID, edx    ; Save the command ID for TBN_TOOLBARCHANGE
                  INVOKE     SendMessage, hWndTool, TB_SETBUTTONINFO, edx, addr tbi
                   popad
               .endif
                  mov     [ebx.TBNOTIFY].cchText, 32
                  mov     [ebx.TBNOTIFY].pszText, ecx
                  mov     eax, TRUE
                  ret
            .else
                  mov     eax, FALSE
                  ret
            .endif

         .elseif eax == TBN_TOOLBARCHANGE
               lea     ecx, szTextA
               mov     tbi.dwMask, TBIF_TEXT
               mov     tbi.pszText, ecx
            INVOKE     SendMessage, hWndTool, TB_SETBUTTONINFO, SavID, addr tbi
               mov     eax, FALSE
               ret
         .endif
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;Insert between if any
;++++ Toolbar Dropdown Notify code ++++++++++++++++++++++++++++++++++++++++++
;---------- [Toolbar Dropdown Notify] ----------
         .if eax == TBN_DROPDOWN
               mov     eax, [ebx.NMTOOLBAR].iItem ; Item num
            INVOKE     SendMessage, hWndTool, TB_COMMANDTOINDEX, eax, 0
               mov     ecx, eax
            INVOKE     SendMessage, hWndTool, TB_GETITEMRECT, ecx, addr rect
              push     rect.top
              push     rect.left
            INVOKE     GetWindowRect, hWndTool, addr rect
               pop     eax
               add     rect.left, eax
               pop     eax
               add     eax, 28
               add     rect.top, eax
            INVOKE     TrackPopupMenu, hSMenu, TPM_LEFTALIGN or TPM_LEFTBUTTON,\
                       rect.left, rect.top, 0, hWnd, 0
         .endif
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

         jmp     DefWin

;---------- [System and user commands] ----------
      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
           cwde                          ; Only low word contains command
         .if eax == IDM_NEW
            INVOKE     SendMessage, hREdit, WM_SETTEXT, 0, offset szNull
            INVOKE     SendMessage, hREdit, EM_SETMODIFY, FALSE, 0
            INVOKE     SetFocus, hREdit

         .elseif eax == IDM_OPEN

         .elseif eax == IDM_SAVE

         .elseif eax == IDM_EXIT
            INVOKE     SendMessage, hwnd, WM_CLOSE, 0 ,0

         .elseif eax == IDM_CUT
            INVOKE     SendMessage, hREdit, WM_CUT, 0 ,0

         .elseif eax == IDM_COPY
            INVOKE     SendMessage, hREdit, WM_COPY, 0 ,0

         .elseif eax == IDM_PASTE
            INVOKE     SendMessage, hREdit, WM_PASTE, 0 ,0

         .elseif eax == IDM_DELETE
            INVOKE     SendMessage, hREdit, WM_CLEAR, 0 ,0

         .elseif eax == IDM_SELALL
            INVOKE     SendMessage, hREdit, EM_SETSEL, 0, -1

         .elseif eax == IDM_FIND

         .elseif eax == IDM_FINDNEXT

         .elseif eax == IDM_FINDPREV

         .elseif eax == IDM_REPLACE

         .endif

      .elseif wMsg == WM_CLOSE
         INVOKE     DestroyWindow, hwnd

      .elseif wMsg == WM_DESTROY
;Insert between
;++++ Destroy Imagelist +++++++++++++++++++++++++++++++++++++++++++++++
         INVOKE     ImageList_Destroy, hImageList
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         INVOKE     PostQuitMessage, NULL

      .else

DefWin:
         INVOKE     DefWindowProc, hwnd, wMsg, wParam, lParam
            ret
      .endif

Ret0:
         xor    eax, eax
         ret
WndProc endp

;===================================================
; SubClass the Edit control procedure
;===================================================
RichEditProc PROC hwnd:DWORD, wmsg, wparam, lparam
LOCAL    rect:RECT

      .if wmsg == WM_RBUTTONDOWN
            jmp     PopUp
      .endif
         jmp     ThatsAll

PopUp:
      INVOKE     GetWindowRect, hWnd, addr rect
         mov     ecx, lparam        ; x/y pos of window
         mov     ebx, ecx
         and     ebx, 0000ffffh     ; ebx = LOWORD(lparam) = x pos
         shr     ecx, 16            ; ecx = HIWORD(lparam) = y pos
         add     ebx, rect.left
         add     ecx, rect.top
         add     ebx, 10 
         add     ecx, 70
      INVOKE     TrackPopupMenu, hSMenu, TPM_LEFTALIGN or TPM_LEFTBUTTON,\
                 ebx, ecx, 0, hWnd, addr rect
        jmp      ThatsAll

ThatsAll:
      INVOKE     CallWindowProc, lpRichEdit, hwnd, wmsg, wparam, lparam

         ret
RichEditProc ENDP

;Insert between
;++++ ChgBmpColor PROC ++++++++++++++++++++++++++++++++++++++++++++++++
;===================================================
; ChgBmpColor procedure
;===================================================
ChgBmpColor PROC hBitmap:DWORD
LOCAL    mDC:DWORD, hBrush, hOldBmp, Fill, hOldBrush
      INVOKE     CreateCompatibleDC, NULL
         mov     mDC, eax
      INVOKE     SelectObject, mDC, hBitmap
         mov     hOldBmp, eax
      INVOKE     GetSysColor, COLOR_BTNFACE
      INVOKE     CreateSolidBrush, eax
         mov     hBrush, eax
      INVOKE     SelectObject, mDC, hBrush
         mov     hOldBrush, eax
         mov     Fill, 00c0c0c0h
      INVOKE     ExtFloodFill, mDC, 0, 0, Fill, FLOODFILLSURFACE
      INVOKE     ExtFloodFill, mDC, 0, 15, Fill, FLOODFILLSURFACE
      INVOKE     ExtFloodFill, mDC, 15, 0, Fill, FLOODFILLSURFACE
      INVOKE     ExtFloodFill, mDC, 15, 15, Fill, FLOODFILLSURFACE
      INVOKE     SelectObject, mDC, hOldBrush
      INVOKE     DeleteObject, hBrush
      INVOKE     SelectObject, mDC, hBitmap
        push     eax
      INVOKE     DeleteDC, mDC
         pop     eax
         ret
ChgBmpColor ENDP
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;Insert between if any
;++++ Create Docking Toolbar PROC +++++++++++++++++++++++++++++++++++++
;======================================================
; Create Docking Toolbar PROCEDURE
;======================================================
DockToolbar PROC
LOCAL    rect:RECT

      .if hWndDock
         INVOKE     DestroyWindow, hWndDock
      .endif

      INVOKE     CreateWindowEx, WS_EX_TOOLWINDOW, addr FloatTBClass,
                 0, WS_POPUPWINDOW or WS_CAPTION or\
                 WS_VISIBLE or WS_THICKFRAME, 0, 0, 0, 0,\
                 hWnd, NULL, hInst, NULL
         mov     hWndDock, eax

      INVOKE     SetParent, hWndTool, hWndDock
      INVOKE     GetClientRect, hWnd, addr rect
         mov     edx, rect.bottom
         shl     edx, 16
         mov     ecx, rect.right
         mov     dx, cx
      INVOKE     SendMessage, hWnd, WM_SIZE, 0, edx

         ret
DockToolbar ENDP
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;Insert between if any
;++++ FloatWndProc PROC +++++++++++++++++++++++++++++++++++++++++++++++
;===================================================
; FloatWndProc procedure
;===================================================
FloatWndProc PROC  uses ebx esi edi hwnd:DWORD, wmsg, wparam, lparam
LOCAL    rect:RECT
LOCAL    rectE:RECT
LOCAL    rectF:RECT
LOCAL    Cnt:DWORD, WH, Var, swOn
LOCAL    szBuff[64]:BYTE

         mov     eax, hwnd
      .if eax == hWndDock
         .if wmsg == WM_CLOSE || wmsg == WM_RBUTTONDBLCLK
            INVOKE     SetParent, hWndTool, hWnd
            INVOKE     DestroyWindow, hWndDock
               and     hWndDock, 0
            INVOKE     GetWindowLong, hWndTool, GWL_STYLE
               mov     Styles, eax
            .if !(Styles & WS_BORDER)
                  xor     Styles, WS_BORDER
            .endif
            INVOKE     SetWindowLong, hWndTool, GWL_STYLE, Styles
            .if FloatLock
               INVOKE     GetWindowRect, hWndFloat, addr rectF
               INVOKE     GetClientRect, hREdit, addr rectE
                  mov     eax, rectF.left
                  sub     rectF.right, eax
                  mov     eax, rectF.top
                  sub     rectF.bottom, eax

                  add     rectF.top, 26
                  mov     eax, rectF.right
               .if rectF.bottom > eax
                     sub     rectF.top, 3
                     sub     rectF.bottom, 26
               .endif
                  mov     LockOn, 1
               INVOKE     MoveWindow, hWndFloat, rectF.left, rectF.top, rectF.right, rectF.bottom, TRUE
                  mov     FloatLock, 1
            .endif
              call     SetSize

               mov     eax, 1
               ret
         .endif
            jmp     DefWin
      .endif

      .if wmsg == WM_NCLBUTTONDBLCLK
         INVOKE     PostMessage, hWndFloat, WM_NCLBUTTONDOWN, HTCAPTION, 0
      .endif
         mov     eax, hwnd
      .if eax != hWndFloat
            mov     eax, 1
            ret
      .endif

      .if wmsg == WM_MOVE
         INVOKE     SetFocus, hREdit
         .if !ToolW
               mov     eax, TRUE
               ret
         .endif
            and     swOn, 0
         INVOKE     GetWindowRect, hWndFloat, addr rectF ; Rectangle of Float
         INVOKE     GetWindowRect, hREdit, addr rectE ; Rectangle of Edit

            mov     eax, lparam       ; Get xPos
            and     eax, 0ffffh       ; Lowword
            mov     ecx, lparam       ; Get yPos
            shr     ecx, 16           ; Hiword

            add     rectE.left, 6
            add     rectE.top, 6

         .if eax < 10 || eax > 7fffh || ecx > 7fffh
            .if eax > 10
                 push     eax
               INVOKE     GetWindowRect, hWndFloat, addr rectF ; Rectangle of Float
                 push     rectF.left
                 push     rectF.top
               INVOKE     GetClientRect, hWndFloat, addr rectF ; Rectangle of Float
                  pop     ecx
                  pop     edx
                  pop     eax
               .if eax > 7fffh
                     mov     rectF.top, ecx
               .else
                     mov     rectF.left, edx
               .endif
                  add     rectF.right, 6
                  add     rectF.bottom, 6
               INVOKE     MoveWindow, hWndFloat, rectF.left, rectF.top, rectF.right, rectF.bottom, TRUE
            .endif
               and     FloatLock, 0
               xor     eax, eax
               ret
         .endif

            mov     ebx, eax
            sub     eax, 10
            add     ebx, 10
            mov     edx, ecx
            sub     ecx, 10
            add     edx, 10

         .if eax < rectE.left && ebx > rectE.left &&\
             ecx < rectE.top && edx > rectE.top || LockOn
               and     LockOn, 0
               mov     FloatLock, 1
            INVOKE     GetClientRect, hWndFloat, addr rectF
            INVOKE     GetClientRect, hREdit, addr rectE
               mov     eax, rectF.right
            .if eax > rectF.bottom
                  mov     WH, 1
                  mov     eax, 22  ; Height
                 push     rectE.right
                 push     eax
            .else
                  mov     WH, 2
                  mov     eax, 23  ; Width
                 push     rectE.bottom
                 push     eax
            .endif
               jmp     NewPos

         .else
            INVOKE     GetClientRect, hWndFloat, addr rectF
               and     FloatLock, 0
              call     SetSize
            INVOKE     GetWindowRect, hWndFloat, addr rect
            INVOKE     SendMessage, hWndToolF, TB_BUTTONCOUNT, 0, 0
               mov     Cnt, eax
            .if rectF.right == 23 || rectF.bottom == 22
               .if rectF.right == 23
                    imul     eax, 22
                     mov     rectF.bottom, eax
               .elseif rectF.bottom == 22
                    imul     eax, 23
                     mov     rectF.right, eax
               .endif

                  mov     WH, 1
                 push     rectF.right
                 push     rectF.bottom
                  jmp     NewPos
            .endif
         .endif
            mov     eax, TRUE
            ret
      .endif

      .if wmsg == WM_SIZE
         INVOKE     SendMessage, hWndToolF, TB_BUTTONCOUNT, 0, 0
            mov     Cnt, eax
         .if !eax
               jmp     DefWin
         .endif
         INVOKE     GetClientRect, hREdit, addr rectE
         INVOKE     GetWindowRect, hWndFloat, addr rect
            mov     eax, lparam       ; Get width
            and     eax, 0ffffh       ; Lowword
            mov     ebx, lparam       ; Get height
            shr     ebx, 16           ; Hiword

         .if !ToolW
               mov     ToolW, eax
               mov     ToolH, ebx
               dec     ToolW
         .endif

            and     swOn, 0
            xor     edx, edx
         .if FloatLock && ebx == ToolH && eax != ToolW
               mov     WH, 1
               mov     eax, 22  ; Height
              push     rectE.right
              push     eax
               mov     swOn, 1
               jmp     NewPos
         .endif
         .if FloatLock && eax == ToolW && ebx != ToolH
               mov     WH, 2
               mov     eax, 23  ; Width
              push     rectE.bottom
              push     eax
               mov     swOn, 2
               jmp     NewPos
         .endif

         .if eax != ToolW || ebx != ToolH
               mov     WH, 1
               mov     ecx, 22
            .if ebx != ToolH
                  mov     WH, 2
                  mov     ecx, 23
                  mov     eax, ebx
            .endif
               div     ecx
            .if edx
                  inc     eax
            .endif
            .if eax > Cnt
                  mov     eax, Cnt
            .endif

DoAgain:
            .if !eax
                  mov     eax, 1
            .endif
               mov     ebx, eax

               mov     Var, 22
            .if WH == 1
                  mov     Var, 23
            .endif
              imul     eax, Var

              push     eax           ; W if WH == 1
               xor     edx, edx
               mov     eax, Cnt
               div     ebx
            .if !eax
                  inc     eax
            .endif
            .if edx
                  inc     eax
            .endif

            .if WH == 2 && eax == 2 || WH == 2 && eax == 3
              imul     ebx, eax
               .if ebx > Cnt
                  .if eax == 3
                        pop     eax
                        xor     edx, edx
                        mov     eax, Cnt
                        mov     ebx, 3
                        div     ebx
                        jmp     DoAgain
                  .endif
                     pop     eax
                     mov     eax, Cnt
                     jmp     DoAgain
               .endif
            .endif

               mov     Var, 23
            .if WH == 1
                  mov     Var, 22
            .endif
              imul     eax, Var
              push     eax           ; H if WH == 1

NewPos:
            INVOKE     GetWindowRect, hWndFloat, addr rect
            .if WH == 1
                  pop     eax
                  pop     ebx
            .else
                  pop     ebx
                  pop     eax
            .endif

               mov     ToolW, ebx
               mov     ToolH, eax
               mov     rect.right, ebx
               mov     rect.bottom, eax
               add     rect.right, 6
               add     rect.bottom, 6

            .if FloatLock
                  and     FloatLock, 0
                 call     SetSize
                  mov     FloatLock, 1
               INVOKE     GetWindowRect, hREdit, addr rectE
                MOVmd     rect.left, rectE.left
                MOVmd     rect.top, rectE.top
               INVOKE     GetClientRect, hREdit, addr rectE
               .if swOn
                  .if swOn == 1
                        jmp     sw01
                  .else
                        jmp     sw02
                  .endif
                     jmp     PressOn
               .endif
               INVOKE     GetClientRect, hWndFloat, addr rectF
                  mov     eax, rectF.right
               .if eax > rectF.bottom
sw01:
                     mov     rect.bottom, 22  ; Height
                     mov     ToolH, 22
                     add     rect.bottom, 6
                   MOVmd     rect.right, rectE.right
                     add     rect.right, 6
               .else
sw02:
                     mov     rect.right, 23   ; Width
                     mov     ToolW, 23
                     add     rect.right, 6
                   MOVmd     rect.bottom, rectE.bottom
                     add     rect.bottom, 6
               .endif
            .endif

PressOn:
            INVOKE     MoveWindow, hWndFloat, rect.left, rect.top, rect.right, rect.bottom, TRUE
            INVOKE     GetClientRect, hWndFloat, addr rect
               add     rect.right, 2
               add     rect.bottom, 2
            INVOKE     MoveWindow, hWndToolF, -1, -1, rect.right, rect.bottom, TRUE
              call     SetSize
         .endif
            jmp     Ret0

      .elseif wmsg == WM_NOTIFY
            mov     ebx, lparam                      ; Get pointer to NMHDR
            mov     eax, (NMHDR ptr [ebx]).code
         .if eax == TTN_NEEDTEXT
               mov     eax, (NMHDR ptr [ebx]).idFrom ; Resource id
               mov     ebx, eax
            INVOKE     LoadString, hInst, ebx, addr szBuff, lengthof szBuff
               mov     ebx, lparam                   ; Get the buffer addr
               lea     eax, szBuff
               mov     (TOOLTIPTEXT ptr [ebx]).lpszText, eax
               jmp     Ret0
         .endif
            jmp     DefWin

      .elseif wmsg == WM_COMMAND
         INVOKE     SendMessage, hWnd, WM_COMMAND, wparam, lparam
         INVOKE     SetFocus, hREdit
            xor     eax, eax
            jmp     Ret0
      .endif

DefWin:
      INVOKE     DefWindowProc, hwnd, wmsg, wparam, lparam
         ret

Ret0:
         xor     eax, eax
         ret
FloatWndProc ENDP
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;Insert between if any
;++++ SetSize PROC ++++++++++++++++++++++++++++++++++++++++++++++++++++
;======================================================
; Call WM_SIZE PROCEDURE
;======================================================
SetSize PROC
LOCAL    rect:RECT

      INVOKE     GetClientRect, hWnd, addr rect
         mov     edx, rect.bottom
         shl     edx, 16
         mov     ecx, rect.right
         mov     dx, cx
      INVOKE     SendMessage, hWnd, WM_SIZE, 0, edx
         ret

SetSize ENDP
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

end start